=== doc/CMakeLists.txt ===
#
#
find_package(Doxygen)

if(DOXYGEN_FOUND)
  #----------------------------------------------------------------------
  # User documentation
  #----------------------------------------------------------------------
  #set(user_doc_file_in ${CMAKE_CURRENT_SOURCE_DIR}/UserDoc.in)
  #set(user_doc_file ${CMAKE_CURRENT_BINARY_DIR}/UserDoc)

  #configure_file(${user_doc_file_in} ${user_doc_file} @ONLY)
  #add_custom_target( user_doc
  #  COMMAND ${DOXYGEN_EXECUTABLE} ${user_doc_file}
  #  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  #  COMMENT "Generating User documentation"
  #  VERBATIM)
  #----------------------------------------------------------------------
  # Developer documentation
  #----------------------------------------------------------------------
  set(dev_doc_file_in ${CMAKE_CURRENT_SOURCE_DIR}/DevDoc.cfg.in)
  set(dev_doc_file ${CMAKE_CURRENT_BINARY_DIR}/DevDoc.cfg)

  configure_file(${dev_doc_file_in} ${dev_doc_file} @ONLY)
  add_custom_target( dev_doc
    COMMAND ${DOXYGEN_EXECUTABLE} ${dev_doc_file}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating Developer documentation"
    VERBATIM)
endif(DOXYGEN_FOUND)
