=== src/CMakeLists.txt ===
#------------------------------------------------------------------------
# -*- mode: cmake -*-
#------------------------------------------------------------------------
ADD_SUBDIRECTORY(client)
ADD_SUBDIRECTORY(util)
