=== swig/CMakeLists.txt ===
find_package(SWIG 2.0.4 REQUIRED)

add_subdirectory(common)

add_subdirectory(java)
if( NOT WIN32 )
add_subdirectory(octave)
endif( NOT WIN32 )
add_subdirectory(python)

add_subdirectory(matlab)
