=== swig/matlab/CMakeLists.txt ===
FIND_PACKAGE(SWIG 2.0.4 REQUIRED)

set( ENABLE_SWIG_MATLAB "yes"
  CACHE INTERNAL "Control the building of MATLAB extensions" )

add_subdirectory(module)
add_subdirectory(test)
