=== swig/octave/CMakeLists.txt ===
# -*- mode: cmake; conding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4

find_package(SWIG 3.0.7)

#========================================================================
# Discover if Octave is available and usable
#========================================================================
find_package(HDF5)
find_package(Octave)

if (OCTAVE_FOUND AND SWIG_FOUND)
  message("The Swig version is ${SWIG_VERSION}")
  message("Octave version is ${OCTAVE_VERSION_STRING}")
  set( ENABLE_SWIG_OCTAVE "yes"
       CACHE INTERNAL "Control the building of the SWIG bindings for Octave" )
  find_library( OCTAVE_OCTAVE_LIBRARY
                NAMES octave
		HINTS ${OCTAVE_LINK_DIRS} )
  find_library( OCTAVE_INTERP_LIBRARY
                NAMES octinterp
		HINTS ${OCTAVE_LINK_DIRS} )
  set( OCTAVE_LIBRARIES
       ${OCTAVE_INTERP_LIBRARY}
       ${OCTAVE_OCTAVE_LIBRARY} )

endif(OCTAVE_FOUND AND SWIG_FOUND)

add_subdirectory(module)
add_subdirectory(test)
