=== swig/python/CMakeLists.txt ===
# -*- mode: cmake; conding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
find_package(SWIG 2.0.4 REQUIRED)

add_subdirectory(module)
add_subdirectory(test)
