=== debian/control ===
Source: nds2-client
Section: net
Priority: optional
Maintainer: Edward Maros <ed.maros@ligo.org>
Build-Depends:
 debhelper (>= 7.0.50),
 cmake,
 gawk,
 pkg-config,
 libsqlite3-dev,
 swig (>= 3.0.7),
 python,
 dh-python,
 python-dev,
 python-numpy,
 default-jdk,
 octave | octave3.2 | octave3.0,
 octave-pkg-dev,
 liboctave-dev | octave3.2-headers | octave3.0-headers,
 libkrb5-dev,
 libsasl2-dev,
 libsasl2-modules,
 libsasl2-modules-gssapi-mit
Standards-Version: 3.9.6
Homepage: https://trac.ligo.caltech.edu/nds2
Vcs-Svn: https://svn.ligo.caltech.edu/svn/nds2/client

Package: nds2-client
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 krb5-user
Suggests:
 libnds2-client-java,
 octave-nds2-client,
 python-nds2-client
Description: NDS2 client binaries
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes some client binary examples.

#========================================================================
# Currently the cmake rules do not support making of the man pages.
#========================================================================
#Package: nds2-client-man
#Section: doc
#Architecture: all
#Depends:
# ${misc:Depends}
#Description: NDS2 client man pages
# The Network Data Server (NDS) is a TCP/IP protocol for retrieving
# online or archived data from thousands of instrument channels at LIGO
# (Laser Interferometer Gravitational-Wave Observatory) sites and data
# analysis clusters.  Version 2 of the protocol includes communication
# with Kerberos and GSSAPI.
# .
# This package includes client man pages.

Package: libnds2-client
Architecture: any
Replaces: nds2-client-lib (<< 0.10.0-1)
Breaks: nds2-client-lib (<< 0.10.0-1)
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 libsasl2-modules,
 libsasl2-modules-gssapi-mit
Description: NDS2 client libraries
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes the client C++ library.

Package: libnds2-client-dev
Section: libdevel
Architecture: any
Replaces: nds2-client-dev (<< 0.10.0-1)
Breaks: nds2-client-dev (<< 0.10.0-1)
Depends:
 ${misc:Depends},
 libnds2-client (= ${binary:Version})
Description: NDS2 client development files
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes the client C++ development files.

Package: nds2-client-lib
Section: oldlibs
Priority: extra
Architecture: all
Depends:
 ${misc:Depends},
 libnds2-client (= ${binary:Version})
Description: NDS2 client libraries (transitional)
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This is a transitional dummy package for libnds2-client.  It can be
 safetly removed.

Package: nds2-client-dev
Section: oldlibs
Priority: extra
Architecture: all
Depends:
 ${misc:Depends},
 libnds2-client-dev (= ${binary:Version})
Description: NDS2 client development files (transitional)
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This is a transitional dummy package for libnds2-client-dev.  It can
 be safetly removed.

Package: libnds2-client-java
Section: java
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: NDS2 client java interface
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes the SWIG-generated java bindings, which are
 also usable from Matlab.

Package: octave-nds2-client
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 octave
Description: NDS2 client octave bindings
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes the SWIG-generated octave bindings.

Package: python-nds2-client
Section: python
Architecture: any
Depends:
 ${python:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: NDS2 client python bindings
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes the SWIG-generated python bindings.

Package: libnds2-client-matlab
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libnds2-client-java (= ${binary:Version})
Description: NDS2 client MATLAB interface
 This provides MATLAB wrappers for the nds2 client

Package: nds2-client-all
Architecture: any
Depends:
 ${misc:Depends},
 nds2-client (= ${binary:Version}),
 libnds2-client (= ${binary:Version}),
 libnds2-client-dev (= ${binary:Version}),
 libnds2-client-java (= ${binary:Version}),
 libnds2-client-matlab (= ${binary:Version}),
 octave-nds2-client (= ${binary:Version}),
 python-nds2-client (= ${binary:Version})
Description: NDS2 meta package
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package installs all NDS2 client packages, including libraries,
 language bindings, binary interface, and documentation.
